diff --git a/src/backend/parser/parse_clause.c b/src/backend/parser/parse_clause.c
index ca26f6f61f2..7cc7deed92b 100644
--- a/src/backend/parser/parse_clause.c
+++ b/src/backend/parser/parse_clause.c
@@ -20,9 +20,11 @@
 #include "access/table.h"
 #include "access/tsmapi.h"
 #include "catalog/catalog.h"
+#include "catalog/pg_aggregate.h"
 #include "catalog/pg_am.h"
 #include "catalog/pg_amproc.h"
 #include "catalog/pg_constraint.h"
+#include "catalog/pg_proc.h"
 #include "catalog/pg_type.h"
 #include "commands/defrem.h"
 #include "miscadmin.h"
@@ -1146,6 +1148,26 @@ transformFromClauseItem(ParseState *pstate, Node *n,
 		rte->tablesample = transformRangeTableSample(pstate, rts);
 		return rel;
 	}
+	else if (IsA(n, RangePivot))
+	{
+		/* PIVOT clause (wrapping some other valid FROM node) */
+		RangePivot *rp = (RangePivot *) n;
+		Node	   *rel;
+
+		/* Recursively transform the contained source relation */
+		rel = transformFromClauseItem(pstate, rp->source,
+									  top_nsitem, namespace);
+
+		/* Store for Phase 2 - error if multiple PIVOTs */
+		if (pstate->p_pivot_clause != NULL)
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("multiple PIVOT clauses are not supported"),
+					 parser_errposition(pstate, rp->location)));
+
+		pstate->p_pivot_clause = rp->pivot;
+		return rel;
+	}
 	else if (IsA(n, JoinExpr))
 	{
 		/* A newfangled join expression */
@@ -3886,3 +3908,547 @@ transformFrameOffset(ParseState *pstate, int frameOptions,
 
 	return node;
 }
+
+
+/*
+ * ============================================================================
+ * PIVOT clause transformation
+ * ============================================================================
+ *
+ * The PIVOT clause transforms rows into columns using aggregation, providing
+ * compatibility with SQL Server and Oracle pivot syntax.
+ *
+ * Syntax:
+ *   SELECT row_columns
+ *   FROM source_table
+ *   PIVOT (aggregate(value_column) FOR pivot_column IN (value1, value2, ...))
+ *
+ * Example:
+ *   SELECT region
+ *   FROM sales
+ *   PIVOT (SUM(revenue) FOR quarter IN ('Q1', 'Q2', 'Q3', 'Q4'))
+ *
+ * This is semantically equivalent to:
+ *   SELECT region,
+ *          SUM(revenue) FILTER (WHERE quarter = 'Q1') AS "Q1",
+ *          SUM(revenue) FILTER (WHERE quarter = 'Q2') AS "Q2",
+ *          ...
+ *   FROM sales
+ *   GROUP BY region
+ *
+ * Implementation notes:
+ * - PIVOT transforms to FILTER aggregates at parse time (no executor changes)
+ * - Row identifiers (columns in SELECT not involved in pivot) are grouped
+ * - Any aggregate function is supported (not just built-in ones)
+ * - SELECT * is not allowed because we need to distinguish row identifiers
+ *   from pivot/value columns at parse time
+ * - Explicit GROUP BY is not allowed as PIVOT generates its own GROUP BY
+ *
+ * References:
+ * - Oracle PIVOT: https://docs.oracle.com/en/database/oracle/oracle-database/19/sqlrf/SELECT.html#GUID-CFA006CA-6FF1-4972-821E-6996142A51C6
+ * - SQL Server PIVOT: https://docs.microsoft.com/en-us/sql/t-sql/queries/from-using-pivot-and-unpivot
+ */
+
+/*
+ * validatePivotAggregate - validate that the function is a valid aggregate
+ *
+ * This checks the system catalogs to verify the specified function is actually
+ * an aggregate function, rather than hardcoding specific aggregate names.
+ * This allows user-defined aggregates to work with PIVOT.
+ */
+static void
+validatePivotAggregate(ParseState *pstate, PivotClause *pivot)
+{
+	List	   *funcname = pivot->aggName;
+	Oid			funcid;
+	Oid			rettype;
+	Oid		   *argtypes;
+	int			nargs;
+	bool		retset;
+	int			nvargs;
+	Oid			vatype;
+	Oid		  **true_typeids;
+	FuncDetailCode fdresult;
+	char	   *aggname;
+
+	aggname = strVal(llast(funcname));
+
+	/*
+	 * Look up the function. For COUNT(*), we pass no arguments.
+	 * For other aggregates, we use a placeholder type (ANY) since
+	 * we'll resolve the actual type later during transformation.
+	 */
+	if (pivot->valueColumn != NULL)
+	{
+		/*
+		 * For aggregates with a column argument, we look up by name only.
+		 * The actual type checking happens during transformExpr when we
+		 * build the FuncCall node.
+		 */
+		argtypes = NULL;
+		nargs = 0;
+	}
+	else
+	{
+		/* COUNT(*) case - look for aggregate with no args */
+		argtypes = NULL;
+		nargs = 0;
+	}
+
+	/*
+	 * Use func_get_detail to check if this is a valid aggregate.
+	 * We use FUNCDETAIL_AGGREGATE to require it to be an aggregate.
+	 */
+	{
+		int		fgc_flags = 0;
+
+		fdresult = func_get_detail(funcname,
+								   NIL,		/* no explicit args */
+								   NIL,		/* no argument names */
+								   0,		/* no args */
+								   argtypes,
+								   false,	/* not expand_variadic */
+								   false,	/* not expand_defaults */
+								   false,	/* not include_out_arguments */
+								   &fgc_flags,
+								   &funcid,
+								   &rettype,
+								   &retset,
+								   &nvargs,
+								   &vatype,
+								   &true_typeids,
+								   NULL);	/* no argdefaults */
+	}
+
+	/*
+	 * If we can't find it as a no-arg function, that's okay - we'll verify
+	 * it's an aggregate when we actually transform the expression. For now,
+	 * just check that if we found something, it's an aggregate.
+	 */
+	if (fdresult == FUNCDETAIL_AGGREGATE)
+		return;		/* It's a valid aggregate */
+
+	/*
+	 * If we didn't find it as a no-arg aggregate, check pg_proc directly
+	 * to see if there's ANY aggregate with this name in the search path.
+	 */
+	{
+		CatCList   *catlist;
+		int			i;
+		bool		found_aggregate = false;
+
+		catlist = SearchSysCacheList1(PROCNAMEARGSNSP,
+									  CStringGetDatum(aggname));
+
+		for (i = 0; i < catlist->n_members; i++)
+		{
+			HeapTuple	proctup = &catlist->members[i]->tuple;
+			Form_pg_proc procform = (Form_pg_proc) GETSTRUCT(proctup);
+
+			/* Check if this function is an aggregate */
+			if (procform->prokind == PROKIND_AGGREGATE)
+			{
+				found_aggregate = true;
+				break;
+			}
+		}
+
+		ReleaseSysCacheList(catlist);
+
+		if (found_aggregate)
+			return;		/* Found a valid aggregate with this name */
+	}
+
+	/*
+	 * No aggregate found with this name - report error
+	 */
+	ereport(ERROR,
+			(errcode(ERRCODE_UNDEFINED_FUNCTION),
+			 errmsg("function %s is not an aggregate function", aggname),
+			 errhint("PIVOT requires an aggregate function."),
+			 parser_errposition(pstate, pivot->location)));
+}
+
+/*
+ * checkDuplicatePivotValues - check for duplicate pivot values
+ */
+static void
+checkDuplicatePivotValues(ParseState *pstate, PivotClause *pivot)
+{
+	ListCell   *lc1,
+			   *lc2;
+	int			i = 0;
+
+	foreach(lc1, pivot->pivotValues)
+	{
+		Node	   *val1 = (Node *) lfirst(lc1);
+		int			j = 0;
+
+		foreach(lc2, pivot->pivotValues)
+		{
+			Node	   *val2 = (Node *) lfirst(lc2);
+
+			if (j > i && equal(val1, val2))
+			{
+				/*
+				 * Get string representation for error message.
+				 * Use the location from the second (duplicate) value.
+				 */
+				ParseLoc	loc = exprLocation(val2);
+
+				ereport(ERROR,
+						(errcode(ERRCODE_DUPLICATE_OBJECT),
+						 errmsg("duplicate pivot value in IN list"),
+						 parser_errposition(pstate, loc)));
+			}
+			j++;
+		}
+		i++;
+	}
+}
+
+/*
+ * getPivotValueString - get string representation of a pivot value for column naming
+ */
+static char *
+getPivotValueString(Node *val)
+{
+	if (IsA(val, Const))
+	{
+		Const	   *c = (Const *) val;
+		Oid			typoutput;
+		bool		typIsVarlena;
+
+		if (c->constisnull)
+			return pstrdup("NULL");
+
+		getTypeOutputInfo(c->consttype, &typoutput, &typIsVarlena);
+		return OidOutputFunctionCall(typoutput, c->constvalue);
+	}
+	else if (IsA(val, TypeCast))
+	{
+		TypeCast   *tc = (TypeCast *) val;
+
+		return getPivotValueString(tc->arg);
+	}
+	else if (IsA(val, A_Const))
+	{
+		A_Const	   *ac = (A_Const *) val;
+
+		if (ac->isnull)
+			return pstrdup("NULL");
+
+		switch (nodeTag(&ac->val))
+		{
+			case T_Integer:
+				return psprintf("%d", intVal(&ac->val));
+			case T_Float:
+				return pstrdup(castNode(Float, &ac->val)->fval);
+			case T_Boolean:
+				return pstrdup(boolVal(&ac->val) ? "true" : "false");
+			case T_String:
+				return pstrdup(strVal(&ac->val));
+			default:
+				break;
+		}
+	}
+
+	/* Fallback */
+	return pstrdup("value");
+}
+
+/*
+ * buildFilterAggregate - create a target entry for AGG(col) FILTER (WHERE pivot_col = value)
+ */
+static TargetEntry *
+buildFilterAggregate(ParseState *pstate, PivotClause *pivot,
+					 Node *pivotValue, int resno)
+{
+	FuncCall   *fc;
+	Node	   *filterExpr;
+	Node	   *aggExpr;
+	char	   *colname;
+	ColumnRef  *pivotColRef;
+	ParseCallbackState pcbstate;
+
+	/* Create aggregate function call */
+	fc = makeFuncCall(list_copy(pivot->aggName), NIL, COERCE_EXPLICIT_CALL, pivot->location);
+
+	if (pivot->valueColumn != NULL)
+	{
+		fc->args = list_make1(copyObject(pivot->valueColumn));
+		fc->agg_star = false;
+	}
+	else
+	{
+		fc->agg_star = true;
+	}
+
+	/* Create filter expression: pivot_column = pivot_value */
+	pivotColRef = makeNode(ColumnRef);
+	pivotColRef->fields = list_make1(makeString(pivot->pivotColumn));
+	pivotColRef->location = pivot->location;
+
+	filterExpr = (Node *) makeSimpleA_Expr(AEXPR_OP, "=",
+										   (Node *) pivotColRef,
+										   copyObject(pivotValue),
+										   pivot->location);
+	fc->agg_filter = filterExpr;
+
+	/* Set up error callback for transformExpr */
+	setup_parser_errposition_callback(&pcbstate, pstate, pivot->location);
+
+	/* Transform the aggregate expression */
+	aggExpr = transformExpr(pstate, (Node *) fc, EXPR_KIND_SELECT_TARGET);
+
+	cancel_parser_errposition_callback(&pcbstate);
+
+	/* Get column name from pivot value */
+	colname = getPivotValueString(pivotValue);
+
+	return makeTargetEntry((Expr *) aggExpr,
+						   (AttrNumber) resno,
+						   colname,
+						   false);
+}
+
+/*
+ * findColumnInTargetList - find column by name in target list
+ */
+static TargetEntry *
+findColumnInTargetList(List *targetList, const char *colname)
+{
+	ListCell   *lc;
+
+	foreach(lc, targetList)
+	{
+		TargetEntry *tle = (TargetEntry *) lfirst(lc);
+
+		if (tle->resname != NULL && strcmp(tle->resname, colname) == 0)
+			return tle;
+	}
+
+	return NULL;
+}
+
+/*
+ * transformPivotClause - transform the PIVOT clause of a SELECT statement
+ *
+ * This function:
+ * 1. Validates the pivot specification
+ * 2. Builds FILTER aggregates for each pivot value
+ * 3. Generates GROUP BY for row identifiers
+ */
+void
+transformPivotClause(ParseState *pstate, Query *qry)
+{
+	PivotClause *pivot = pstate->p_pivot_clause;
+	List	   *newTargetList = NIL;
+	List	   *rowIdentifiers = NIL;
+	List	   *pivotValueStrings = NIL;
+	ListCell   *lc;
+	int			resno = 1;
+	Index		sortgroupref = 1;
+
+	if (pivot == NULL)
+		return;
+
+	/*
+	 * Note: SELECT * check is performed earlier in transformSelectStmt()
+	 * before we get here. At this point, we have already validated that
+	 * the user provided explicit column names.
+	 *
+	 * The check is done there because we need access to the original
+	 * stmt->targetList (with A_Star nodes) before transformation expands
+	 * the star into individual columns.
+	 */
+
+	/* Validate aggregate function */
+	validatePivotAggregate(pstate, pivot);
+
+	/* Check for duplicate pivot values */
+	checkDuplicatePivotValues(pstate, pivot);
+
+	/* Build list of pivot value strings for comparison */
+	foreach(lc, pivot->pivotValues)
+	{
+		Node	   *pval = (Node *) lfirst(lc);
+
+		pivotValueStrings = lappend(pivotValueStrings, getPivotValueString(pval));
+	}
+
+	/*
+	 * Validate that the pivot column exists in the source.
+	 * We check by seeing if the column can be resolved.
+	 */
+	{
+		ColumnRef  *pivotColRef = makeNode(ColumnRef);
+		Node	   *result;
+		ParseCallbackState pcbstate;
+
+		pivotColRef->fields = list_make1(makeString(pivot->pivotColumn));
+		pivotColRef->location = pivot->location;
+
+		setup_parser_errposition_callback(&pcbstate, pstate, pivot->location);
+
+		result = transformExpr(pstate, (Node *) pivotColRef, EXPR_KIND_SELECT_TARGET);
+
+		cancel_parser_errposition_callback(&pcbstate);
+
+		if (result == NULL)
+		{
+			ereport(ERROR,
+					(errcode(ERRCODE_UNDEFINED_COLUMN),
+					 errmsg("pivot column \"%s\" does not exist", pivot->pivotColumn),
+					 parser_errposition(pstate, pivot->location)));
+		}
+	}
+
+	/*
+	 * Validate that the value column (if specified) exists in the source.
+	 */
+	if (pivot->valueColumn != NULL)
+	{
+		Node	   *result;
+		ParseCallbackState pcbstate;
+
+		setup_parser_errposition_callback(&pcbstate, pstate, exprLocation(pivot->valueColumn));
+
+		result = transformExpr(pstate, copyObject(pivot->valueColumn), EXPR_KIND_SELECT_TARGET);
+
+		cancel_parser_errposition_callback(&pcbstate);
+
+		if (result == NULL)
+		{
+			ereport(ERROR,
+					(errcode(ERRCODE_UNDEFINED_COLUMN),
+					 errmsg("value column in PIVOT aggregate does not exist"),
+					 parser_errposition(pstate, exprLocation(pivot->valueColumn))));
+		}
+	}
+
+	/*
+	 * Check for column conflicts BEFORE processing:
+	 * If any column in SELECT (that is NOT the pivot column) has a name
+	 * that matches a pivot value, this creates a naming conflict.
+	 * The user would have both a row identifier AND a pivot output with
+	 * the same name.
+	 */
+	foreach(lc, qry->targetList)
+	{
+		TargetEntry *tle = (TargetEntry *) lfirst(lc);
+		ListCell   *lc2;
+
+		if (tle->resjunk || tle->resname == NULL)
+			continue;
+
+		/* Skip if this is the pivot column itself */
+		if (strcmp(tle->resname, pivot->pivotColumn) == 0)
+			continue;
+
+		/* Check if this column name matches any pivot value */
+		foreach(lc2, pivotValueStrings)
+		{
+			char	   *pvStr = (char *) lfirst(lc2);
+
+			if (strcmp(tle->resname, pvStr) == 0)
+			{
+				ereport(ERROR,
+						(errcode(ERRCODE_DUPLICATE_COLUMN),
+						 errmsg("pivot value \"%s\" conflicts with column \"%s\" in SELECT list",
+								pvStr, tle->resname),
+						 errhint("Rename the column or use a different pivot value."),
+						 parser_errposition(pstate, pivot->location)));
+			}
+		}
+	}
+
+	/*
+	 * Process the existing target list to identify:
+	 * - Row identifier columns (kept and grouped by)
+	 * - The pivot column is excluded from row identifiers
+	 */
+	foreach(lc, qry->targetList)
+	{
+		TargetEntry *tle = (TargetEntry *) lfirst(lc);
+
+		if (tle->resjunk)
+			continue;
+
+		/* Skip the pivot column - it's not a row identifier */
+		if (tle->resname != NULL && strcmp(tle->resname, pivot->pivotColumn) == 0)
+			continue;
+
+		/* This is a row identifier - keep it and add to GROUP BY */
+		{
+			TargetEntry *newTle;
+			SortGroupClause *sgc;
+			Oid			eqop,
+						sortop;
+			bool		hashable;
+			Oid			restype;
+			ParseCallbackState pcbstate;
+
+			/* Copy the target entry with new resno */
+			newTle = flatCopyTargetEntry(tle);
+			newTle->resno = resno++;
+
+			/* Add to GROUP BY */
+			newTle->ressortgroupref = sortgroupref;
+
+			restype = exprType((Node *) tle->expr);
+
+			setup_parser_errposition_callback(&pcbstate, pstate, pivot->location);
+
+			get_sort_group_operators(restype,
+									 true, true, false,
+									 &sortop, &eqop, NULL,
+									 &hashable);
+
+			cancel_parser_errposition_callback(&pcbstate);
+
+			sgc = makeNode(SortGroupClause);
+			sgc->tleSortGroupRef = sortgroupref++;
+			sgc->eqop = eqop;
+			sgc->sortop = sortop;
+			sgc->reverse_sort = false;
+			sgc->nulls_first = false;
+			sgc->hashable = hashable;
+
+			qry->groupClause = lappend(qry->groupClause, sgc);
+
+			rowIdentifiers = lappend(rowIdentifiers, newTle);
+			newTargetList = lappend(newTargetList, newTle);
+		}
+	}
+
+	/*
+	 * Now add FILTER aggregates for ALL pivot values.
+	 * Each pivot value becomes a new output column.
+	 */
+	{
+		ListCell   *lc2;
+
+		foreach(lc2, pivot->pivotValues)
+		{
+			Node	   *pivotVal = (Node *) lfirst(lc2);
+			TargetEntry *newTle;
+
+			newTle = buildFilterAggregate(pstate, pivot, pivotVal, resno++);
+			newTargetList = lappend(newTargetList, newTle);
+		}
+	}
+
+	/* Update the query */
+	qry->targetList = newTargetList;
+
+	/* Mark that this query has aggregates */
+	pstate->p_hasAggs = true;
+	qry->hasAggs = true;
+
+	/* Store the pivot clause in query for view deparsing */
+	qry->pivotClause = pivot;
+
+	/* Clean up */
+	list_free_deep(pivotValueStrings);
+}
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 556ab057e5a..38a581548bf 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -520,6 +520,7 @@ static void get_from_clause_coldeflist(RangeTblFunction *rtfunc,
 									   deparse_context *context);
 static void get_tablesample_def(TableSampleClause *tablesample,
 								deparse_context *context);
+static void get_pivot_clause(PivotClause *pivot, deparse_context *context);
 static void get_opclass_name(Oid opclass, Oid actual_datatype,
 							 StringInfo buf);
 static Node *processIndirection(Node *node, deparse_context *context);
@@ -12391,6 +12392,13 @@ get_from_clause(Query *query, const char *prefix, deparse_context *context)
 			pfree(itembuf.data);
 		}
 	}
+
+	/*
+	 * If this query has a PIVOT clause, emit it after the FROM items.
+	 * This allows views with PIVOT to round-trip through pg_get_viewdef.
+	 */
+	if (query->pivotClause != NULL)
+		get_pivot_clause(query->pivotClause, context);
 }
 
 static void
@@ -12881,6 +12889,195 @@ get_tablesample_def(TableSampleClause *tablesample, deparse_context *context)
 	}
 }
 
+/*
+ * get_pivot_clause			- deparse a PIVOT clause
+ *
+ * Outputs the PIVOT syntax: PIVOT (agg(col) FOR pivot_col IN (values))
+ */
+static void
+get_pivot_clause(PivotClause *pivot, deparse_context *context)
+{
+	StringInfo	buf = context->buf;
+	ListCell   *lc;
+	bool		first;
+
+	appendStringInfoString(buf, " PIVOT (");
+
+	/* Aggregate function name */
+	if (list_length(pivot->aggName) == 1)
+	{
+		appendStringInfoString(buf, strVal(linitial(pivot->aggName)));
+	}
+	else
+	{
+		/* Qualified name */
+		first = true;
+		foreach(lc, pivot->aggName)
+		{
+			if (!first)
+				appendStringInfoChar(buf, '.');
+			first = false;
+			appendStringInfoString(buf, quote_identifier(strVal(lfirst(lc))));
+		}
+	}
+
+	/* Aggregate argument */
+	appendStringInfoChar(buf, '(');
+	if (pivot->valueColumn != NULL)
+	{
+		/*
+		 * The valueColumn is a ColumnRef (raw parse node), not a Var.
+		 * We need to handle it specially since get_rule_expr doesn't
+		 * know about raw parse nodes.
+		 */
+		if (IsA(pivot->valueColumn, ColumnRef))
+		{
+			ColumnRef  *cref = (ColumnRef *) pivot->valueColumn;
+			ListCell   *field;
+			bool		firstField = true;
+
+			foreach(field, cref->fields)
+			{
+				Node	   *fn = (Node *) lfirst(field);
+
+				if (!firstField)
+					appendStringInfoChar(buf, '.');
+				firstField = false;
+
+				if (IsA(fn, String))
+					appendStringInfoString(buf, quote_identifier(strVal(fn)));
+				else if (IsA(fn, A_Star))
+					appendStringInfoChar(buf, '*');
+			}
+		}
+		else
+		{
+			/* Fallback for other node types */
+			get_rule_expr(pivot->valueColumn, context, false);
+		}
+	}
+	else
+		appendStringInfoChar(buf, '*');
+	appendStringInfoChar(buf, ')');
+
+	/* FOR clause */
+	appendStringInfoString(buf, " FOR ");
+	appendStringInfoString(buf, quote_identifier(pivot->pivotColumn));
+
+	/* IN list */
+	appendStringInfoString(buf, " IN (");
+	first = true;
+	foreach(lc, pivot->pivotValues)
+	{
+		Node	   *val = (Node *) lfirst(lc);
+
+		if (!first)
+			appendStringInfoString(buf, ", ");
+		first = false;
+
+		/*
+		 * Pivot values may be A_Const (raw parse node) or TypeCast.
+		 * Handle them specially since get_rule_expr doesn't know about
+		 * raw parse nodes.
+		 */
+		if (IsA(val, A_Const))
+		{
+			A_Const	   *con = (A_Const *) val;
+
+			if (con->isnull)
+				appendStringInfoString(buf, "NULL");
+			else
+			{
+				switch (nodeTag(&con->val))
+				{
+					case T_Integer:
+						appendStringInfo(buf, "%d", intVal(&con->val));
+						break;
+					case T_Float:
+						appendStringInfoString(buf, castNode(Float, &con->val)->fval);
+						break;
+					case T_Boolean:
+						appendStringInfoString(buf, boolVal(&con->val) ? "TRUE" : "FALSE");
+						break;
+					case T_String:
+						/* Quote the string value */
+						appendStringInfoChar(buf, '\'');
+						{
+							const char *s = strVal(&con->val);
+							for (; *s; s++)
+							{
+								if (*s == '\'')
+									appendStringInfoChar(buf, '\'');
+								appendStringInfoChar(buf, *s);
+							}
+						}
+						appendStringInfoChar(buf, '\'');
+						break;
+					case T_BitString:
+						appendStringInfoString(buf, strVal(&con->val));
+						break;
+					default:
+						elog(ERROR, "unexpected A_Const value type: %d",
+							 (int) nodeTag(&con->val));
+				}
+			}
+		}
+		else if (IsA(val, TypeCast))
+		{
+			TypeCast   *tc = (TypeCast *) val;
+
+			/* Recursively handle the argument */
+			if (IsA(tc->arg, A_Const))
+			{
+				A_Const	   *con = (A_Const *) tc->arg;
+
+				if (!con->isnull && nodeTag(&con->val) == T_String)
+				{
+					appendStringInfoChar(buf, '\'');
+					{
+						const char *s = strVal(&con->val);
+						for (; *s; s++)
+						{
+							if (*s == '\'')
+								appendStringInfoChar(buf, '\'');
+							appendStringInfoChar(buf, *s);
+						}
+					}
+					appendStringInfoChar(buf, '\'');
+				}
+			}
+			/* Append the type cast */
+			appendStringInfoString(buf, "::");
+			/* Format the type name */
+			{
+				TypeName   *tn = tc->typeName;
+				ListCell   *l;
+				bool		firstN = true;
+
+				foreach(l, tn->names)
+				{
+					if (!firstN)
+						appendStringInfoChar(buf, '.');
+					firstN = false;
+					appendStringInfoString(buf, quote_identifier(strVal(lfirst(l))));
+				}
+			}
+		}
+		else
+		{
+			/* Fallback to get_rule_expr for Const nodes */
+			get_rule_expr(val, context, false);
+		}
+	}
+	appendStringInfoString(buf, ")");
+
+	appendStringInfoChar(buf, ')');
+
+	/* Alias */
+	if (pivot->alias != NULL)
+		appendStringInfo(buf, " AS %s", quote_identifier(pivot->alias->aliasname));
+}
+
 /*
  * get_opclass_name			- fetch name of an index operator class
  *
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index d14294a4ece..0747fb3dc87 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -98,6 +98,9 @@ typedef uint64 AclMode;			/* a bitmask of privilege bits */
  *	Query Tree
  *****************************************************************************/
 
+/* Forward declaration for PIVOT clause */
+typedef struct PivotClause PivotClause;
+
 /*
  * Query -
  *	  Parse analysis turns all statements into a Query tree
@@ -217,6 +220,8 @@ typedef struct Query
 	bool		groupDistinct;	/* was GROUP BY DISTINCT used? */
 	bool		groupByAll;		/* was GROUP BY ALL used? */
 
+	PivotClause *pivotClause;	/* PIVOT clause if present, for view deparsing */
+
 	List	   *groupingSets;	/* a list of GroupingSet's if present */
 
 	Node	   *havingQual;		/* qualifications applied to groups */
@@ -730,6 +735,40 @@ typedef struct RangeTableSample
 	ParseLoc	location;		/* method name location, or -1 if unknown */
 } RangeTableSample;
 
+/*
+ * PivotClause - represents the PIVOT clause specification
+ *
+ * This node captures the aggregate function, value column, pivot column,
+ * and list of pivot values for a PIVOT operation.
+ */
+typedef struct PivotClause
+{
+	NodeTag		type;
+	List	   *aggName;		/* aggregate function name (List of String) */
+	Node	   *valueColumn;	/* column to aggregate, NULL for COUNT(*) */
+	char	   *pivotColumn;	/* column whose values become output columns */
+	List	   *pivotValues;	/* List of Const nodes for pivot values */
+	Alias	   *alias;			/* optional alias for result */
+	ParseLoc	location;		/* PIVOT keyword location, or -1 if unknown */
+} PivotClause;
+
+/*
+ * RangePivot - PIVOT appearing in a raw FROM clause
+ *
+ * This node, appearing only in raw parse trees, represents
+ *		<relation> PIVOT (agg(col) FOR pivot_col IN (values)) [AS alias]
+ * The source can be a RangeVar, RangeSubselect, or JoinExpr.
+ * Similar to RangeTableSample, RangePivot wraps around the source relation.
+ */
+typedef struct RangePivot
+{
+	NodeTag		type;
+	Node	   *source;			/* source relation (RangeVar, RangeSubselect, or JoinExpr) */
+	PivotClause *pivot;			/* the PIVOT clause specification */
+	Alias	   *alias;			/* optional alias for the pivoted result */
+	ParseLoc	location;		/* PIVOT keyword location, or -1 if unknown */
+} RangePivot;
+
 /*
  * ColumnDef - column definition (used in various creates)
  *
diff --git a/src/include/parser/kwlist.h b/src/include/parser/kwlist.h
index 5d4fe27ef96..7c1b2d641f9 100644
--- a/src/include/parser/kwlist.h
+++ b/src/include/parser/kwlist.h
@@ -343,6 +343,7 @@ PG_KEYWORD("passing", PASSING, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("password", PASSWORD, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("path", PATH, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("period", PERIOD, UNRESERVED_KEYWORD, BARE_LABEL)
+PG_KEYWORD("pivot", PIVOT, TYPE_FUNC_NAME_KEYWORD, BARE_LABEL)
 PG_KEYWORD("placing", PLACING, RESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("plan", PLAN, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("plans", PLANS, UNRESERVED_KEYWORD, BARE_LABEL)
diff --git a/src/include/parser/parse_clause.h b/src/include/parser/parse_clause.h
index ede3903d1dd..23ccd40d104 100644
--- a/src/include/parser/parse_clause.h
+++ b/src/include/parser/parse_clause.h
@@ -55,4 +55,7 @@ extern bool targetIsInSortList(TargetEntry *tle, Oid sortop, List *sortList);
 /* functions in parse_jsontable.c */
 extern ParseNamespaceItem *transformJsonTable(ParseState *pstate, JsonTable *jt);
 
+/* PIVOT transformation */
+extern void transformPivotClause(ParseState *pstate, Query *qry);
+
 #endif							/* PARSE_CLAUSE_H */
diff --git a/src/include/parser/parse_node.h b/src/include/parser/parse_node.h
index f7d07c84542..9415b924a18 100644
--- a/src/include/parser/parse_node.h
+++ b/src/include/parser/parse_node.h
@@ -231,6 +231,8 @@ struct ParseState
 
 	Node	   *p_last_srf;		/* most recent set-returning func/op found */
 
+	PivotClause *p_pivot_clause;	/* PIVOT clause for deferred processing */
+
 	/*
 	 * Optional hook functions for parser callbacks.  These are null unless
 	 * set up by the caller of make_parsestate.
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index cc6d799bcea..12366e491e2 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -63,6 +63,11 @@ test: sanity_check
 # ----------
 test: select_into select_distinct select_distinct_on select_implicit select_having subselect union case join aggregates transactions random portals arrays btree_index hash_index update delete namespace prepared_xacts
 
+# ----------
+# PIVOT test
+# ----------
+test: pivot
+
 # ----------
 # Another group of parallel tests
 # ----------
